Package: likelihood
Version: 1.9
Title: Methods for Maximum Likelihood Estimation
Date: 2023-03-30
Authors@R: c(person("Lora", "Murphy", role = c("aut", "cre"), email="murphyl@caryinstitute.org"))
Author: Lora Murphy [aut, cre]
Maintainer: Lora Murphy <murphyl@caryinstitute.org>
Description: Tools for maximum likelihood estimation of parameters 
  of scientific models. Based on Goffe et al (1994) <doi:10.1016/0304-4076(94)90038-8>.
Depends: R (>= 2.1.1), nlme
License: GPL-2
LazyData: true
NeedsCompilation: no
Packaged: 2023-03-30 14:44:19 UTC; lora
Repository: CRAN
Date/Publication: 2023-03-30 16:50:04 UTC
Built: R 4.6.0; ; 2026-04-27 10:25:18 UTC; unix

Package: likelihood
Version: 1.9
Title: Methods for Maximum Likelihood Estimation
Date: 2023-03-30
Authors@R: c(person("Lora", "Murphy", role = c("aut", "cre"), email="murphyl@caryinstitute.org"))
Author: Lora Murphy [aut, cre]
Maintainer: Lora Murphy <murphyl@caryinstitute.org>
Description: Tools for maximum likelihood estimation of parameters 
  of scientific models. Based on Goffe et al (1994) <doi:10.1016/0304-4076(94)90038-8>.
Depends: R (>= 2.1.1), nlme
License: GPL-2
LazyData: true
NeedsCompilation: no
Packaged: 2023-03-30 14:44:19 UTC; lora
Repository: CRAN
Date/Publication: 2023-03-30 16:50:04 UTC
Built: R 4.6.0; ; 2026-04-26 01:04:17 UTC; unix

##
## ANNEALING 1: simulated annealing to maximize negative log
## likelihood for the following:
## Model: Radius = a + b * DBH
## Dataset: included crown_rad dataset
##

library(likelihood)

# Set up our dataset
data(crown_rad)
dataset = crown_rad

# Create our model function
modelfun = function (a, b, DBH) {a + b * DBH}

# Create a place to put our parameters and
# set initial values for a and b
par = list(a = 0, b = 0)

# Create a place to put all the other values, and indicate
# that DBH comes from the column marked "DBH"
# in the dataset
var = list(DBH = "DBH")

# Set bounds
par_lo=list(a = 0, b = 0)
par_hi=list(a = 50, b = 50)

# We'll use the normal probability distribution function 
# add the options for it to our parameter list
# "x" value in PDF is observed value
var$x="Radius"

# Mean in normal PDF: use the reserved word "predicted"
# to indicate that this is where the output from the scientific 
# model function goes
var$mean="predicted"
var$sd=0.815585

# Have it calculate log likelihood
var$log=TRUE

results=anneal(model = modelfun, par = par, var = var, 
  source_data = dataset, par_lo = par_lo, par_hi = par_hi,
  pdf = dnorm, dep_var = "Radius", max_iter = 20000)
  
cat("Max likelihood should be about negative 119.7454.  Result: ", results$max_likeli, "\n")
cat("Best a should be about 1.117194.  Result: ", results$best_pars$a, "\n")
cat("Best b should be about 0.06755417.  Result: ", results$best_pars$b, "\n")

##
## TEST 1 - calculation of negative log likelihood
## Model: Radius = a + b * DBH
## Dataset: included crown_rad dataset
##

library(likelihood)

# Set up our dataset
data(crown_rad)
dataset <- crown_rad

# Create our model function
model <- function (a, b, DBH) {a + b * DBH}

# Create a place to put our parameters and values,
# set values for a and b, and indicate
# that DBH comes from the column marked "DBH"
# in the dataset
par <- list(a = 1.12, b = 0.07)
var <- list(DBH = "DBH")

# We'll use the normal probability distribution function -
# add the options for it to our parameter list
# "x" value in PDF is observed value
var$x<-"Radius"

# Mean in normal PDF
var$mean<-"predicted"
var$sd<-0.815585

# Have it calculate log likelihood
var$log<-TRUE

result<-likeli(model, par, var, dataset, dnorm)
cat("This result should be -119.969: ", result)

# Try other values for a and b
par$a<-0
par$b<-0.115
var$sd<-0.962325
result<-likeli(model, par, var, dataset, dnorm)
cat("This result should be -139.382: ", result)

par$a<-2.36
par$b<-0
var$sd<-1.094228
result<-likeli(model, par, var, dataset, dnorm)
cat("This result should be -148.89: ", result)

# Do it through predicted_results
predicted <- predicted_results(model, par, var, dataset)
result <- sum(dnorm(x=dataset$Radius, mean=predicted, sd=var$sd,log=TRUE))
cat("This result should be -148.89: ", result)

##
## TEST 3 - calculation of negative log likelihood
## with variance of probability distribution function
## a function of DBH
## Model: Radius = a + b * DBH
## Variance: Variance = c * DBH (we'll take the square
## root to make standard deviation)
## Our parameters are a, b, and c
## Dataset: included crown_rad dataset
##

library(likelihood)

# Set up our dataset
data(crown_rad)
dataset <- crown_rad

# Create our model function
model <- function (a, b, DBH, species) {
  a[species] + b * DBH
}

# Create our variance function
varfun <- function(c, DBH) {sqrt(c * DBH)}

# Create a place to put our parameters and
# set initial values for a and b, and indicate
# that DBH comes from the column marked "DBH"
# in the dataset
par <- list(a = c(1.12, 1.0, 1.5), b = 0.07, c = 0.05)

# Create a place for all other values, starting with
# values from the dataset
var <- list(species="Species", DBH = "DBH")

# We'll use the normal probability distribution function -
# add the options for it to our parameter list
# "x" value in PDF is observed value
var$x<-"Radius"

# Mean in normal PDF
var$mean<-"predicted"
var$sd<-varfun

# Have it calculate log likelihood
var$log<-TRUE

result<-likeli(model, par, var, dataset, dnorm)

cat("This result should be -138.5: ", result)

##
## TEST 2 - calculation of negative log likelihood
## with multiple functions called from the model
## Model: Height = a + b * N where N = r * X
## and a = q + p * DBH
## Parameters are b, q, and r
## Dataset: included from_sortie dataset
##

library(likelihood)

# Set up our dataset
data(from_sortie)

# Create our model function
model <- function (a, b, N) {a + b * N}
# Put in a default which we will not provide in
# the parameter list
afun <- function(q, p=1.3, DBH) {q + p * DBH}

# Create a place to put our parameters and
# set initial values for b, q, and r
par<-list(b = 3.4, q = -6.5, r = 0.01)

# Create the N function
nfun <- function(r, X) {r * X}

# Set up our var list, with non-parameters information.
# Say that a and N are function results
var <- list( a = afun, N = nfun)

# Put in the parameters for sumneigh
var$target_data <- from_sortie
var$DBH <- "DBH"
var$X <- "X"

# We'll use the normal probability distribution function -
# add the options for it to our parameter list
# "x" value in PDF is observed value
var$x<-"Height"

# Mean in normal PDF
var$mean<-"predicted"
var$sd<-4.123106

# Have it calculate log likelihood
var$log<-TRUE

result<-likeli(model, par, var, from_sortie, dnorm)

cat("This result should be -429.678: ", result)

##
## Annealing run with variance of probability distribution
## function a function of DBH and sub-indexing on parameters
## Model: Radius = a + b * DBH
## Variance: Variance = c * DBH (we'll take the square
## root to make standard deviation)
## Dataset: included crown_rad dataset
##

library(likelihood)

# Set up our dataset
data(crown_rad)
dataset <- crown_rad

# Create our model function
model <- function (a, b, DBH, species) {
  a[species] + b * DBH
}

# Create our variance function
varfun <- function(c, DBH) {sqrt(c * DBH)}

# Create a place to put our parameters and
# set initial values for a and b, and indicate
# that DBH comes from the column marked "DBH"
# in the dataset
par<-list(a = c(0.8, 1.0, 1.5), b = 0.07, c = 0.05)
var<-list(species="Species", DBH = "DBH")

par_lo <- list( a = c(0, 0, 0), b = 0, c = 0)
par_hi <- list( a = c(2, 2, 2), b = 10, c = 10)

# We'll use the normal probability distribution function -
# add the options for it to our parameter list
# "x" value in PDF is observed value
var$x<-"Radius"

# Mean in normal PDF
var$mean<-"predicted"
var$sd<-varfun

# Have it calculate log likelihood
var$log<-TRUE

results<-anneal(model=model, par=par, var=var, source_data=dataset, 
par_lo=par_lo, par_hi=par_hi, pdf=dnorm, dep_var="Radius",
max_iter=20000)

cat("Max likelihood should be about -110.163.  Result: ", results$max_likeli, "\n")
cat("Best a1 should be about 0.503.  Result: ", results$best_pars$a[1], "\n")
cat("Best a2 should be about 0.945.  Result: ", results$best_pars$a[2], "\n")
cat("Best a3 should be about 0.744.  Result: ", results$best_pars$a[3], "\n")
cat("Best b should be about 0.088.  Result: ", results$best_pars$b, "\n")
cat("Best c should be about 0.0375.  Result: ", results$best_pars$c, "\n")

##
## Simulated annealing to find maximum likelihood estimates of a and b in
## the following model:
## Model: Radius = a + b * DBH
## Dataset: included crown_rad dataset
## This is a global, unbounded search.
##

library(likelihood)

# Set up our dataset
data(crown_rad)
dataset <- crown_rad

# Create our model function
modelfun <- function (a, b, DBH) {a + b * DBH}

# Create a place to put our parameters and
# set initial values for a and b, and indicate
# that DBH comes from the column marked "DBH"
# in the dataset
par <- list(a = 0, b = 0)

# Create a place to put all the other values
var <- list(DBH = "DBH")

# We'll use the normal probability distribution function -
# add the options for it to our parameter list
# "x" value in PDF is observed value
var$x<-"Radius"

# Mean in normal PDF
var$mean<-"predicted"
var$sd<-0.815585

# Have it calculate log likelihood
var$log<-TRUE

results<-anneal(model = modelfun, par = par, var = var, 
  source_data = dataset, pdf = dnorm, dep_var = "Radius", max_iter = 20000)

cat("Max likelihood should be about -119.7454.  Result: ", results$max_likeli, "\n")
cat("Best a should be about 1.117194.  Result: ", results$best_pars$a, "\n")
cat("Best b should be about 0.06755417.  Result: ", results$best_pars$b, "\n")
